class CamerasPanel extends SqRootScript
{
	t = null;
	function OnSim()
	{
		if(!IsDataSet("CameraLinked"))
			MakeLinks();
		SetTheShit();
	}
	
	function SelectedLinkObj()
	{
		local AllLinks = Link.GetAll("ScriptParams",self);
		local num = -1;
		while(AllLinks.AnyLinksLeft())
		{
			if(LinkTools.LinkGetData(AllLinks.Link(),"") == "Spyable")
			{
				num++;
				if(num >= GetData("nth_selected"))
					return LinkDest(AllLinks.Link());
			}
			
			AllLinks.NextLink();
		}
		return null;
	}
	
	function GetRest()
	{
		local tab = {
			"id_screen":null,
			"alert1_lt":null,
			"alert2_lt":null,
			"alert3_lt":null,
			"disabled_lt":null,
			"noCam_lt":null,
			"disable_switch":null
			};
		local AllLinks = Link.GetAll("ScriptParams",self);
		local data = null;
		
		foreach(v in AllLinks)
		{
			data = LinkTools.LinkGetData(v,"");
			if(data in tab)
			{
				tab[data] = LinkDest(v);
			}
		}
		return tab;
	}
	
	function OnRefresh()
	{
		SetTheShit();
	}
	
	function SetTheShit()
	{
		
		
		
		SetData("SLO",SelectedLinkObj());
		local SLO = GetData("SLO");
		local data_tab = GetRest();
		
		//print(data_tab.id_screen);

		
		if(SLO != null)
		{
			if(data_tab.noCam_lt != null)
				SendMessage(data_tab.noCam_lt, "TurnOff");
				
			if(data_tab.disable_switch != null)
			{
				local AllLinks = Link.GetAll("ControlDevice",data_tab.disable_switch);
				foreach(v in AllLinks)
				{
					if(Object.InheritsFrom(LinkDest(v),ObjID("Inverter")))
						Object.Destroy(LinkDest(v));
					else
						Link.Destroy(v);
				}
				Link.Create("ControlDevice",data_tab.disable_switch,SLO);
				if(data_tab.disabled_lt != null)
				{
					local inverter = Object.Create(ObjID("Inverter"));
					Link.Create("ControlDevice",data_tab.disable_switch,inverter);
					Link.Create("ControlDevice",inverter,data_tab.disabled_lt);
				}
			}	
			
			//print("ALERTNESS = "+Property.Get(SLO,"AI_Alertness","Level").tostring());
			if(data_tab.alert1_lt != null)
			{
				if(Property.Get(SLO,"AI_Alertness","Level").tostring() == "1")
					SendMessage(data_tab.alert1_lt, "TurnOn"); 
				else
					SendMessage(data_tab.alert1_lt, "TurnOff");
			}
			if(data_tab.alert2_lt != null)
			{
				if(Property.Get(SLO,"AI_Alertness","Level").tostring() == "2")
					SendMessage(data_tab.alert2_lt, "TurnOn");
				else
					SendMessage(data_tab.alert2_lt, "TurnOff");
			}
			if(data_tab.alert3_lt != null)
			{
				
				if(Property.Get(SLO,"AI_Alertness","Level").tostring() == "3")
					SendMessage(data_tab.alert3_lt, "TurnOn");
				else
					SendMessage(data_tab.alert3_lt, "TurnOff");
			}
			
			if(data_tab.disabled_lt != null)
			{
				if(Property.Get(SLO,"AI_Mode") == 0){
					Light.Activate(data_tab.disabled_lt);
					if(data_tab.disable_switch != null)
						SendMessage(data_tab.disable_switch, "TurnOff");
					}
				else{
					Light.Deactivate(data_tab.disabled_lt);
					if(data_tab.disable_switch != null)
						SendMessage(data_tab.disable_switch, "TurnOn");
					}
			}
			//print("BOING");
			if(data_tab.id_screen != null)
			{
				local InLetters = SLO.tostring();
				//print("LENGHT "+InLetters.len().tostring());
				if(InLetters.len() < 4)
					for(local x = InLetters.len();x < 4;x++)
					{
						InLetters = "0"+InLetters;
					}
				Property.Set(data_tab.id_screen,"StTweqJoints" ,"AnimS",3);
				//print("THIS IS ID IN STRING = "+InLetters);
				for(local x = 1;x<= 4;x++)
				{
					local rlh_name = "    rate-low-high"
					if(x>1)
						rlh_name = "    rate-low-high"+x.tostring()
					//print("VOSTRE LETTRINE    = "+InLetters.slice(4-x,5-x));
					local pos_rot = InLetters.slice(4-x,5-x).tofloat()*36;//[4-(1+x)].tofloat()*36;
					//print("VOSTRE ANGELURE    ="+pos_rot.tostring());
					
					Property.Set(data_tab.id_screen,"StTweqJoints" ,"Joint"+x.tostring()+"AnimS",0);
					local state = Property.Get(data_tab.id_screen,"JointPos" ,"Joint "+x.tostring());
					//local path_left = pos_rot - state;
					//if(path_left < 0)path_left+=360;
					
					if(pos_rot > state){
						Property.Set(data_tab.id_screen,"CfgTweqJoints",rlh_name,vector(30*x,state,pos_rot));
						Property.Set(data_tab.id_screen,"StTweqJoints" ,"Joint"+x.tostring()+"AnimS",1);}
					else if(pos_rot < state){
						Property.Set(data_tab.id_screen,"CfgTweqJoints",rlh_name,vector(30*x,pos_rot,state));
						Property.Set(data_tab.id_screen,"StTweqJoints" ,"Joint"+x.tostring()+"AnimS",3);}


				}
				Property.Set(data_tab.id_screen,"StTweqJoints" ,"AnimS",1);

			}
		
		}
		else
			if(data_tab.noCam_lt != null)
				SendMessage(data_tab.noCam_lt, "TurnOn");
				
	}
	
	function OnTurnOn()
	{
		if(GetData("nth_selected") < GetData("CameraLinked")-1 )
			SetData("nth_selected",GetData("nth_selected")+1);
		else
			SetData("nth_selected",0);
		
		SetTheShit();
		
	}
	
	function OnTurnOff()
	{
		if(GetData("nth_selected") > 0 )
			SetData("nth_selected",GetData("nth_selected")-1);
		else
			SetData("nth_selected",GetData("CameraLinked")-1);
		SetTheShit();
	}
	
	function OnFrobWorldEnd()
	{
		local SLO = GetData("SLO");
		if(SLO != null)
		{
			DrkInv.AddSpeedControl("DONTMOVE",0,0);
			t = SetOneShotTimer("isLooking",0.0014);
			
			local cam_handler = Object.Create(ObjID("Marker"));
			SetData("handler",cam_handler);
			
			local nu_link = Link.Create("DetailAttachement",cam_handler,SLO);
			LinkTools.LinkSetData(nu_link,"Type",1);
			LinkTools.LinkSetData(nu_link,"rel pos",vector(0,2,-0.5));
			LinkTools.LinkSetData(nu_link,"rel rot","125,0,90");
			
			Camera.StaticAttach(cam_handler);
		}
		else
			SetTheShit();
	}
	
	function OnTimer()
	{
		if(message().name == "isLooking")
		{
			if(Camera.GetCameraParent() != ObjID("Player"))
				t = SetOneShotTimer("isLooking",0.0014);
			else{
				DrkInv.RemoveSpeedControl("DONTMOVE");
				KillTimer(t);
				Object.Destroy(GetData("handler"));
				ClearData("handler");
				}
		}
	}
	
	function MakeLinks()
	{
		SetData("nth_selected",0);
		local AllLinks = Link.GetAll("ScriptParams",self);
		local data = null;
		local valid_links = 0;
		foreach(v in AllLinks)
		{
			data = LinkTools.LinkGetData(v,"");
			if(data == "Spyable")
			{
				valid_links++;
			}
		}
		if(valid_links <= 0) //No cameras linked? Well, let's link ourself to ALL of them!
		{
			valid_links = AllCamerasAreMine();
		}
		SetData("CameraLinked",valid_links);
	}
	
	function AllCamerasAreMine()
	{
		local ID = 6000;
		local cam_amount = 0;
		while(ID > 0)
		{
			if(Object.Exists(ID))
				if(Object.InheritsFrom(ID,ObjID("SecCamera2")))
				{
					cam_amount++;
					local l = Link.Create("ScriptParams",self,ID);
					LinkTools.LinkSetData(l,"","Spyable");
				}
			ID--;
		}
		return cam_amount;
	}
}

class ImmortalCamera extends SqRootScript
{
	t = null;
	
	function VecDist(v1,v2)
	{
		return sqrt(pow((v2.x*v1.x),2) + pow((v2.y*v1.y),2) + pow((v2.z*v1.z),2));
	}
	
	function CopyLinks(target,source)
	{
		local ls = Link.GetAll("ControlDevice",source);
		foreach(l in ls)
		{
			Link.Create("ControlDevice",target,LinkDest(l));
		}
		
		ls = Link.GetAll("~ControlDevice",source);
		foreach(l in ls)
		{
			Link.Create("~ControlDevice",target,LinkDest(l));
		}
		
		ls = Link.GetAll("~ScriptParams",source);
		foreach(l in ls)
		{
			local nu_l = Link.Create("~ScriptParams",target,LinkDest(l));
			LinkTools.LinkSetData(nu_l,"",LinkTools.LinkGetData(l,""));
		}
	}
	
	function OnTurnOff()
	{
		t = SetOneShotTimer("KarrasWillReactivate",Data.RandInt(300,600));
	}
	
	function OnTurnOn()
	{
		if(t!=null)
			KillTimer(t);
	}
	
	function OnAlertness()
	{
		Link.BroadcastOnAllLinksData(self, "Refresh", "~ScriptParams", "Spyable");
	}
	
	function OnSlain()
	{
		local nu_me = Object.BeginCreate(Object.Archetype(self));
		Property.CopyFrom(nu_me,"AI_Camera",self);
		CopyLinks(nu_me,self);
		Property.SetSimple(nu_me,"HasRefs",false);
		Object.EndCreate(nu_me);
		Object.Teleport(nu_me,Object.Position(self),Object.Facing(self));
		SetOneShotTimer(nu_me,"BackFromDead",300);
	}
	
	function OnTimer()
	{
		if(message().name == "KarrasWillReactivate")
		{
			KillTimer(t);
			SendMessage(self, "TurnOn");
			Link.BroadcastOnAllLinksData(self, "Refresh", "~ScriptParams", "Spyable");
		}
		
		if(message().name == "BackFromDead")
		{
			t = SetOneShotTimer("CheckIfPlayerIsAway",10);
		}
		if(message().name == "CheckIfPlayerIsAway")
		{
			local v1 = Object.Position(ObjID("Player"));
			local v2 = Object.Position(self);
			if(VecDist(v1,v2) > 64)
			{
				KillTimer(t);
				SendMessage(self, "TurnOn");
				SetProperty("HasRefs",true);
				Object.Destroy(Object.FindClosestObjectNamed(self,"CameraPart"));
			}
			else
				t = SetOneShotTimer("CheckIfPlayerIsAway",10);
		}
	}
}
